import processing.video.*;
import processing.pdf.*;

/*
PDF from movie with srt
 Stéphane Noël - 2013-14
 
 place a movie file and a .srt in the data folder
 fill the informations in the variables below and 
 launch the script to get a PDF
 
 You can tune the page parameters
 - number of images by row
 - number of image by cols
 - margin top, left, right and bottom
 
 Press 'x' to stop the process
 
 Book parameter, fill before launching
 */
 
  String srtFilename = "NightOfTheLivingDead.srt";
 String srtvideoname = "NightOfTheLivingDead.mp4";
 String srtFileoutput = "NightOfTheLivingDead.pdf";
 
 String nomfilm="Night of the\nliving dead";
 String realisateur="George A. Romero";
 String ladate="1968";
 String edition="MoviePrint Editions - 2014";
 String resume="Un cimetière de Pennsylvanie. Barbara et son frère Johnny ont fait une longue route pour venir se recueillir sur la tombe de leur père, enterré dans leur ville natale. Ce rite annuel irrite Johnny, qui se moque de Barbara, et lui rappelle comment il lui faisait peur lorsqu'elle était enfant. Il cherche à nouveau à l'effrayer, en lui affirmant que les morts vont venir la chercher. Barbara, énervée, s'isole, et se fait agresser par une personne à la démarche mécanique et au visage ravagé. Son frère la défend, mais meurt dans la lutte, la tête fracassée contre une pierre tombale. Barbara s'enfuit, et se réfugie dans une maison isolée. Un routier afro-américain, Ben, la rejoint, et bloque portes et fenêtres avec des planches de bois alors que de nombreux morts, revenus à la vie, se dirigent vers la demeure. Barbara s'évanouit, et restera en état de choc à son réveil.";
 
 
  /*
 String srtFilename = "WarGames.1983.srt";
 String srtvideoname = "WarGames.1983.avi";
 String srtFileoutput = "WarGames.pdf";
 
 String nomfilm="Wargames";
 String realisateur="John Badham";
 String ladate="1983";
 String edition="MoviePrint Editions - 2014";
 String resume="David Lightman, un jeune pirate informatique, accède involontairement à WOPR, un supercalculateur militaire des forces armées américaines, programmé pour prédire les résultats possibles d'une guerre nucléaire.\n Lightman obtient de WOPR de lancer une simulation de guerre nucléaire, croyant initialement qu'il ne s'agit que d'un jeu informatique. La simulation cause une panique au niveau national et est près de déclencher la Troisième Guerre mondiale.";
 

 String srtFilename = "into.eternity.2010.srt";
 String srtvideoname = "into.eternity.2010.avi";
 String srtFileoutput = "into.eternity.2010.pdf";
 
 String nomfilm="Into eternity";
 String realisateur="Michael Madsen";
 String ladate="2010";
 String edition="MoviePrint Editions - 2014";
 String resume="Ce documentaire traite du stockage en couche géologique profonde de déchets radioactifs au complexe d'Onkalo, en Finlande. Le bâtiment étant conçu pour exister 100.000 ans, le film pose la question de l'avenir laissé aux générations futures, et de la possibilité de penser, pour des humains, le très long terme.";
 

String srtFilename = "exit.through.the.giftshop-taste.srt";
 String srtvideoname = "exit.through.the.giftshop-taste.avi";
 String srtFileoutput = "exit.through.the.giftshop.pdf";
 
 String nomfilm="Exit through\nthe gift shop";
 String realisateur="Banksy";
 String ladate="2010";
 String edition="MoviePrint Editions - 2014";
 String resume="Thierry Guetta, un commerçant français excentrique, documentariste amateur vivant à Los Angeles et présenté dans le film comme le cousin de l'artiste Space Invader, aurait amassé une considérable archive d'interviews et d'actions de Zevs, Shepard Fairey, André, etc. À mesure qu'il filme de manière compulsive la nouvelle génération de l'art urbain, son obsession pour Banksy, le célèbre pochoiriste britannique se fait plus dévorante. Ils se rencontrent enfin. Banksy incite Guetta, au vu de la médiocrité de ses productions audiovisuelles, à se tourner vers l'art urbain. C'est alors que naît Mr. Brainwash.";
 
 
 String srtFilename = "Clockers.srt";
 String srtvideoname = "Clockers.avi";
 String srtFileoutput = "clockers.pdf";
 
 String nomfilm="Clockers";
 String realisateur="Spike Lee";
 String ladate="1995";
 String edition="MoviePrint Editions - 2014";
 String resume="L'inspecteur Rocco Klein enquête sur le meurtre d'un jeune dealer, tué par Victor Dunham, un jeune père de famille sans histoire. Le policier ne croit cependant pas la version de la légitime défense. L'enquête s'oriente alors vers son jeune frère « Strike », clocker notoire, travaillant pour un parrain du milieu de la drogue.\n\nParallèlement, un jeune d'une douzaine d'années est attiré par l'univers du trafic, la puissance de l'argent et des armes.";
 
 
 String srtFilename = "thetake.srt";
 String srtvideoname = "thetake.avi";
 String srtFileoutput = "The_take.pdf";
 
 String nomfilm="The take";
 String realisateur=" Naomi Klein et Avi Lewis";
 String ladate="2004";
 String edition="MoviePrint Editions - 2014";
 String resume="The take raconte l'histoire de travailleurs de Buenos Aires (Argentine) qui prennent le contrôle d'une usine en faillite où ils étaient employés et la transforme en une coopérative de travailleurs.\n\nLa fermeture de l'usine est montrée comme une conséquence des politiques économiques du gouvernement, plus précisément celle de Carlos Menem, sous l'œil vigilant du Fonds monétaire international.\n\nDans un effort pour établir leur propre contrôle, les travailleurs occupent l'usine et entament une longue bataille pour gagner le droit d'exploiter l'usine sous forme de coopérative. \n\nLe film décrit les combats idéologiques des ouvriers, en montrant comment Carlos Menem poursuit son mandat en dépit de la mauvaise performance de sa politique de privatisation. Mais en fin de compte, les travailleurs gagnent leur combat.";
 
 
 String srtFilename = "Titicut.Follies.srt";
 String srtvideoname = "Titicut.Follies.avi";
 String srtFileoutput = "Titicut.Follies.pdf";
 
 String nomfilm="Titicut Follies";
 String realisateur="Frederick Wiseman";
 String ladate="1967";
 String edition="MoviePrint Editions - 2014";
 String resume="Ce documentaire montre la vie quotidienne des patients détenus dans l'unité carcérale psychiatrique de l'hôpital de Bridgewater. Les conditions de vie des patients sont déplorables. Ils subissent le harcèlement verbal et physique de la part du personnel de l'administration, soignants et gardiens.\nLe film a été censuré après sa sortie aux États-Unis. Bien que le réalisateur ait obtenu, avant de filmer, l'autorisation écrite de l'ensemble des patients incarcérés et des autres intervenants du film, la cour suprême du Massachusetts a estimé que le film violait le droit à la vie privée des patients et a donc ordonné le retrait du film de la circulation.";
 
 
 String srtFilename = "THX 1138.srt";
 String srtvideoname = "THX 1138.avi";
 String srtFileoutput = "THX_1138-moveprint.pdf";
 
 String nomfilm="THX 1138";
 String realisateur="George Lucas";
 String ladate="1971";
 String edition="MoviePrint Editions - 2014";
 String resume="Dans une société souterraine du futur, les hommes vivent sous sédatifs. Ils sont socialement brimés par un pouvoir totalitaire et invisible au sein d'un univers blanc monochrome. Sous l'impulsion de sa compagne LUH 3417, l'ouvrier THX 1138 accepte de fuir avec elle. En conflit avec le chef de LUH 3417 (SEN 5241) qu'il dénonce, THX 1138 se retrouve finalement aussi en prison. THX 1138 est inculpé d'avoir enfreint la règle du sexe interdit avec LUH 3417 et pour n'avoir pas pris certaines des drogues obligatoires (que LUH 3417 lui remplaçait pour le sortir de son état robotique). Les deux hommes s'enfuient de prison à l'aide d'un hologramme humain. Mais SEN 5241 renonce à quitter la cité. THX 1138 y parvient après avoir découvert que LUH 3417 a été exécutée.";
 
 int nbw=2; //nombre d'images en largeur
 int nbh=5; // nombre d'image en hauteur
 int marges_lat=50; // marges latérales du document
 int marge_top=100; // marge du haut
 int marge_bottom=120;
 int marges_int=40; // marges entre images
 int marge_ima_text=10; // marge entre l'image et le sous-titre
 */
/*
parameters for the page
 */

int nbw=2; //nombre d'images en largeur
int nbh=3; // nombre d'image en hauteur
int marges_lat=90; // marges latérales du document
int marge_top=100; // marge du haut
int marge_bottom=120;
int marges_int=20; // marges entre images
int marge_ima_text=8; // marge entre l'image et le sous-titre

int bwidth=1240; // largeur du document
int bheight=1754; // hauteur du document
int tailletexte=8;
int hauteurtexte=36; // hauteur réservée au texte

String hrf="SRT to PDF project : http://www.movieprint.codedrops.net";

PGraphicsPDF pdf;
PFont lapolice, lapolice2;
Movie mov;

color couleur=color(0); 
int pagecount=1;

int compteur=0;
String sub_text="";
int adjuster;
float prev_pointmedian=0;
float intervalle=10.0; // temps entre deux sous-titres accepté sans image intermédiaire
float[] dims;
float px=marges_lat;
float py=marge_top;
float jumph;

void setup() {
  size(bwidth, bheight);
  textAlign(CENTER, CENTER);
  subtitleVector = new ArrayList();
  creervecteur();
  // recuperer le passage du dernier sous-titre
  SubtitleUnit SU=(SubtitleUnit) subtitleVector.get(subtitleVector.size()-1);
  length_srt=SU.endTime+5000;

  mov = new Movie(this, srtvideoname);
  mov.play();
  mov.read();
  delay(500);
  // calcul de la taille des images
  float calcw=(width-((marges_lat*2)+(marges_int*(nbw-1))))/nbw;
  float calch=(height-((marge_top + marge_bottom)+((marge_ima_text+hauteurtexte)*(nbh-1))))/nbh;

  dims=dimensions(mov, calcw, calch);
  float rest=(height - marge_top - marge_bottom)-((dims[1]+marge_ima_text+hauteurtexte)*nbh);
  jumph=(dims[1]+marge_ima_text+hauteurtexte)+(rest/(nbh-1));

  println("cadre : "+calcw+" / "+calch+" - dimensions de l'image : "+dims[0]+" / "+dims[1]);
  //marges_rang=(dims[1]+hauteurtexte+marge_ima_text)*nbh
  pdf = (PGraphicsPDF)beginRecord(PDF, srtFileoutput);
  beginRecord(pdf);
  lapolice=createFont("Montserrat-Regular.ttf", 32);
  lapolice2=createFont("Montserrat-Bold.ttf", 32);

  textAlign(CENTER);
  background(255);
  fill(couleur);
  // creer une couverture

  commencelivre();

  textFont(lapolice, 16);
  textLeading(20);
}

void draw() {

  for (int i=0;i<nbw*nbh;i++) {
    new_subtitle();
    // sauter à son point median entre start et end
    float pointmedian=(sub_start + (sub_end - sub_start))/1000;
    // si il y a trop de temps entre deux sous-titres, placer des images
    if (pointmedian - prev_pointmedian > intervalle) {
      // placer des images sans sous-titre
      // calcul du nomre d'image en fonction de la variable donnée
      int nb_images=int((pointmedian - prev_pointmedian)/intervalle);
      float s=(pointmedian - prev_pointmedian)/nb_images;
      for (float ix=prev_pointmedian+s;ix<pointmedian;ix+=s) {
        affiche_image(ix, "");
        println("intervalle : "+ix);
      }
    }
    affiche_image(pointmedian, sub_text);
    // aficher l'image
    // afficher le sous titre
    println(compteur + " / " + subtitleVector.size());
    prev_pointmedian=pointmedian;
    compteur++;
    if (compteur > subtitleVector.size()-1) { //subtitleVector.size()-1

        // placer des images sans sous-titre
      // calcul du nomre d'image en fonction de la variable donnée
      int nb_images=int((mov.duration() - pointmedian)/intervalle);
      float s=(mov.duration() - prev_pointmedian)/nb_images;
      for (float ix=pointmedian+s;ix<mov.duration();ix+=s) {
        affiche_image(ix, "");
        println("intervalle : "+ix);
      }

      println("fini");

      finitlivre();
      break;
    }
  }
}

void keyPressed() {
  if (key=='x') {
    finitlivre();
  }
}

void commencelivre() {
  mov.jump(random(mov.duration()));
  mov.read();

  float[] tt=calcul_largeur(nomfilm.toUpperCase(), lapolice2, 60, width-(marges_lat*4));

  textFont(lapolice2, tt[0]);
  textLeading(tt[1]*1.2);
  text(nomfilm.toUpperCase(), marges_lat, height*0.15, width-(marges_lat*2), tt[1]*3);

  float illu[]=dimensions(mov, width-(marges_lat*4), height/2);
  image(mov, marges_lat*2, height*0.40, illu[0], illu[1]);

  textFont(lapolice, 44);
  text(realisateur, marges_lat, height*0.81, width-(marges_lat*2), 82);

  textFont(lapolice, 32);
  text(ladate, marges_lat, height*0.85, width-(marges_lat*2), 64);

  textFont(lapolice, 21);
  text(edition, marges_lat, height*0.94, width-(marges_lat*2), 32);

  pdf.nextPage();
}

float[] calcul_largeur(String texte, PFont police, int taille_min, int largeur) {
  boolean ok=false;
  while (ok==false) {
    textFont(police, taille_min+1);
    if (textWidth(texte) > largeur) {
      ok=true;
    } 
    else {
      taille_min++;
    }
  }
  float scalar = 0.8;
  float h=textAscent() + textDescent();
  float[] r= {
    taille_min*1.0, h
  };
  return r;
}

void finitlivre() {
  float p=mov.time();
  bas_de_page(p);

  // page arrière
  pdf.nextPage();

  textFont(lapolice, 26);
  textAlign(LEFT);
  textLeading(38);
  text(resume, marges_lat*3, height*0.32, width-(marges_lat*6), height*0.55);

  textFont(lapolice, 16);
  textAlign(CENTER);
  text(hrf, marges_lat, height*0.93, width-(marges_lat*2), 20);

  textFont(lapolice2, 21);
  text(edition, marges_lat, height*0.95, width-(marges_lat*2), 32);
  endRecord();
  exit();
}

void affiche_image(float p, String str) {
  mov.play();
  mov.jump(p);
  delay(10);
  mov.read();

  image(mov, px, py, dims[0], dims[1]);
  text(str, px, py+dims[1]+marge_ima_text, dims[0], hauteurtexte*2);
  mov.pause();
  px+=dims[0]+marges_int;
  if (px > width-marges_lat) {
    px=marges_lat;
    py+=jumph;
    if (py+dims[1] > height-marge_bottom) {
      px=marges_lat;
      py=marge_top;

      bas_de_page(p);

      pagecount++;
      pdf.nextPage();
      background(255);
    }
  }
}

void bas_de_page(float p) {
  // numero de page
  // afficher le temps
  int temps=int(p);
  int s=temps % 60;
  int m=(temps / 60) % 60;
  int h=(temps/3600) % 24;

  textFont(lapolice2, 11);
  text("( page "+pagecount+" / "+nf(h, 2)+":"+nf(m, 2)+":"+nf(s, 2)+"  )", width/2, height-marges_lat+marges_int);
  textFont(lapolice, 16);
}

float[] dimensions(PImage limage, float tailledw, float tailledh) {
  int largeur=limage.width;
  int hauteur=limage.height;

  float nw=tailledw;
  float nh;
  nh=hauteur/(largeur*1.0/tailledw);

  float[] d = {
    nw, nh
  };
  return d;
}

